<?php
if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}



class threadplugin_zuso_goods {
	
	var $name = 'goods';
	var $iconfile = 'static/icon.png';
	var $buttontext = '';
	
	
	
	public function __construct(){
		$data = file_get_contents('source/plugin/zuso_goods/cData.txt');
		if($data){
			$data = unserialize($data);
			if(isset($data['name']) && $data['name'] !=''){$this->name = $data['name'];}
			if(isset($data['buttontext']) && $data['buttontext']!=''){$this->buttontext = $data['buttontext'];}
		}
	}
	
	
	/**
     * 发主题时页面新增的表单项目
     * @param Integer $fid: 版块ID
     * @return string 通过 return 返回即可输出到发帖页面中 
     */
	
	
    public function newthread($fid) {
        
		//获取设置数据
		global $_G;
        $setData = $_G['cache']['plugin']['zuso_goods'];
		$setData['field'] = $this->getField();
		
        include template('zuso_goods:pc/code');  
		return $code;
    }

    /**
     * 主题发布前的数据判断 
     * @param Integer $fid: 版块ID
     */
    public function newthread_submit($fid) {
		
		$data = $_GET;
		//验证
		if(!$data['img']){
			showmessage(lang('plugin/zuso_goods', 'noimg'));
		}
		
		//存储图片
		foreach($data['img'] as $k=>$v){
			if(preg_match('/^data:image/',$v)){
				$data['img'][$k] = $this->base64Img($v);
			}
		}
		
		global $_G;
		$code['img'] =$this->clear($data['img']);
		$code['field'] = $this->clear($data['field']);
		$code = serialize($code);
		Db::insert('zuso_goods',array('uid'=>$_G['uid'],'code'=>$code,'status'=>0),true);

    }

    /**
     * 主题发布后的数据处理 
     * @param Integer $fid: 版块ID
     * @param Integer $tid: 当前帖子ID
     */
    public function newthread_submit_end($fid, $tid) {
		global $_G;
		DB::update('zuso_goods', ['tid'=>$tid,'status'=>1], ['status' => 0,'uid'=>$_G['uid']]);
    }

    /**
     * 编辑主题时页面新增的表单项目
     * @param Integer $fid: 版块ID
     * @param Integer $tid: 当前帖子ID
     * @return string 通过 return 返回即可输出到编辑主题页面中 
     */
    public function editpost($fid, $tid) {
       
		global $_G;
        $setData = $_G['cache']['plugin']['zuso_goods'];
		$setData['field'] = $this->getField();
        $data = DB::fetch_first('SELECT code FROM %t WHERE tid=%d',array('zuso_goods',$tid));
		$data = unserialize($data['code']);
		
		include template('zuso_goods:pc/editCode');  
		return $code;
    }

    /**
     * 主题编辑前的数据判断 
     * @param Integer $fid: 版块ID
     * @param Integer $tid: 当前帖子ID
     */
    public function editpost_submit($fid, $tid) {
       
	   $data = $_GET;
		//验证
		if(!$data['img']){
			showmessage(lang('plugin/zuso_goods', 'noimg'));
		}
		
		//存储图片
		foreach($data['img'] as $k=>$v){
			if(preg_match('/^data:image/',$v)){
				$data['img'][$k] = $this->base64Img($v);
			}
		}
		
		global $_G;
		$code['img'] =$this->clear($data['img']);
		$code['field'] = $this->clear($data['field']);
		$code = serialize($code);
		
		DB::update('zuso_goods', ['code'=>$code], ['tid'=>$tid]);
    }

    /**
     * 主题编辑后的数据处理 
     * @param Integer $fid: 版块ID
     * @param Integer $tid: 当前帖子ID
     */
    public function editpost_submit_end($fid, $tid) {
        //TODO - Insert your code here
    }

    /**
     * 回帖后的数据处理 
     * @param Integer $fid: 版块ID
     * @param Integer $tid: 当前帖子ID
     */
    public function newreply_submit_end($fid, $tid) {
        //TODO - Insert your code here
        
    }

    /**
     * 查看主题时页面新增的内容
     * @param Integer $tid: 当前帖子ID
     * @return string 通过 return 返回即可输出到主题首贴页面中
     */
    public function viewthread($tid) {
		//--
    }
	
	
	//存储图片
	//base64_image_content base64图片
	public function base64Img($base64_image_content){
		
		//存储路径
		$path = 'data/attachment/forum/'.date('Ym').'/'.date('d').'/';
		if(!is_dir($path)) mkdir($path, 0777,true);
		
		
		//匹配出图片的格式
		if (preg_match('/^(data:\s*image\/(\w+);base64,)/', $base64_image_content, $result)){
			$type = $result[2];
			
			$allowType = array('jpg','jpeg','png','gif');
			if(!in_array($type,$allowType)){
				return false;
			}
			
			if($type == 'jpeg'){$type = 'jpg';}
			$new_file = $path;
			if(!file_exists($new_file)){
				//检查是否有该文件夹，如果没有就创建，并给予最高权限
				mkdir($new_file, 0700);
			}
			$new_file = $new_file.uniqid().'.'.$type;
			if (file_put_contents($new_file, base64_decode(str_replace($result[1], '', $base64_image_content)))){
				return $new_file;
			}else{
				return false;
			}
		}else{
			return false;
		}
	}
	
	//获取数据
	public function getField(){
		$data = file_get_contents('source/plugin/zuso_goods/data.txt');
		$data = unserialize($data);
		
		if(!$data){
			$data = array();
		}
		return $data['field'];
	}
	
	
	//过滤特殊代码
	public function clear($data){
		if(is_array($data)){
			foreach($data as $k=>$v){
				$data[$k] = preg_replace("/<(.*?)>/","",$v);
			}
		}else{
			$data = preg_replace("/<(.*?)>/","",$data);
		}
		return $data;
	}
	
}

?>